{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvRnnDupDg.PAS, released on 2000-12-01.

The Initial Developer of the Original Code is Michael Rynn.
Portions created by Michael Rynn are Copyright (C) 2000  Michael Rynn.
All Rights Reserved.

Contributor(s): ______________________________________.

Last Modified: 2000-12-01

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}

{$I JCL.INC}
unit JvRnnDupDg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls;

type
  TDupAction = (dup_rename, dup_replace, dup_skip, dup_abort);


  TJvRnnDuplicateDg = class(TForm)
    editScriptName: TEdit;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Label2: TLabel;
    procedure ButtonClick(Sender: TObject);
  private
    { Private declarations }
    function GetDupAction : TDupAction;
  public
    { Public declarations }
    property DupAction : TDupAction read GetDupAction;

  end;
var
  JvRnnDuplicateDg: TJvRnnDuplicateDg;

function GetDupAction(var scrname : string) : TDupAction;

implementation

{$R *.DFM}

function GetDupAction(var scrname : string) : TDupAction;
var
	dlg : TJvRnnDuplicateDg;
begin
	dlg := TJvRnnDuplicateDg.Create(Application);
try
	dlg.editScriptName.Text := scrname;
    MessageBeep($FFFF);
    dlg.ShowModal;
    Result := dlg.DupAction;

    if Result=dup_rename then
    	scrname := dlg.editScriptName.Text;

finally
	dlg.Free;
end;

end;

procedure TJvRnnDuplicateDg.ButtonClick(Sender: TObject);
begin
 	Tag := (Sender as TButton).Tag;
    ModalResult := mrOK;
end;


function  TJvRnnDuplicateDg.GetDupAction : TDupAction;
begin
	Result := TDupAction( Tag - 1);
end;

end.


