{-----------------------------------------------------------------------------
The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/MPL-1.1.html

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either expressed or implied. See the License for
the specific language governing rights and limitations under the License.

The Original Code is: JvRnnStrTx.PAS, released on 2000-12-01.

The Initial Developer of the Original Code is Michael Rynn.
Portions created by Michael Rynn are Copyright (C) 2000  Michael Rynn.
All Rights Reserved.

Contributor(s): ______________________________________.

Last Modified: 2000-12-01

You may retrieve the latest version of this file at the Project JEDI home page,
located at http://www.delphi-jedi.org

-----------------------------------------------------------------------------}
{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}

{$I JCL.INC}
unit JvRnnStrTx;

interface
uses classes;

procedure AssignStrings(var F:TextFile;Strings:TStrings);

implementation
uses JvRnnStrUt, Sysutils;

type

  TStringFileIO = record
    Strings : TStrings;
    rdPos : integer;
    Index : integer;
    pushCR : Char;
    pushLF : Char;
  end;

  PStringFileIO = ^TStringFileIO;
  HStringFileIO = ^PStringFileIO;

function DoNothing(var F:TTextRec):integer;far;
begin
  Result := 0;
end;

function Output(var F:TTextRec):integer;far;
var
  str:string;
  NewLine:Boolean;
  ps:pstringFileIO;
begin
  With F do begin
      ps := HStringFileIO(@UserData[1])^;

      with ps^ do begin
          NewLine := False;

        if (BufPos >= 1) and (PChar(BufPtr)[BufPos-1]=#10) then begin
          Dec(BufPos);
            NewLine := true;
            end;

        if (BufPos >= 1) and (PChar(BufPtr)[BufPos-1] = #13) then begin
          Dec(BufPos);
            newline := True;
            end;
        SetString(Str,PChar(BufPtr),BufPos);

        if index < strings.count then
          strings[strings.count-1] := strings[strings.Count-1] + str
        else
          strings.Add(Str);
        BufPos := 0;
      if Newline then
          index := index+1;
        end;
    end;
    Result := 0;
end;

function Input(var F:TTextRec):Integer; far;
var
  maxCopy : integer;
  ps : PStringFileIO;
  tempStr : string;
begin
  Result := 0;
  with F do
  begin
    ps := HStringFileIO(@UserData[1])^;
    with ps^ do
    begin
      BufPos := 0;
      BufEnd  := 0;
      If Index >= Strings.Count then
        BufEnd := 0
      else
      begin { fill up buffer }
        while (BufEnd < BufSize) do
        begin
          if pushCR <> #0 then
          begin
            PChar(BufPtr)[BufEnd] := pushCR;
            Inc(BufEnd);
            pushCR := #0;
          end else
          if pushLF <> #0 then
          begin
            PChar(BufPtr)[BufEnd] := pushLF;
            Inc(BufEnd);
            pushLF := #0;
          end else
          if rdPos > Length(strings[index]) then
          begin
            Inc(index);
            if Index >= strings.Count then
              exit;
            rdPos := 1;
            pushCR := #13;
            pushLF := #10;
          end else
          begin
            maxCopy := Length(strings[index]) - rdPos + 1;
            if maxCopy > integer(BufSize-BufEnd) then
              maxCopy := integer(BufSize-BufEnd);
            tempStr := Copy( strings[index], rdPos,maxCopy);
            Move(tempStr[1], PChar(BufPtr)[BufEnd], maxCopy);
            BufEnd := BufEnd + cardinal(maxCopy);
            rdPos := rdPos + maxCopy;
            end;
          end;
        end;
      end;
    end;
end;

function CloseStrFileIO(var F:TTextRec) : Integer; far;
var
  ps: PStringFileIO;
begin
  ps := HStringFileIO(@F.UserData[1])^;
  FreeMem(ps,sizeof(TStringFileIO));
  Result := 0;
end;

function Open(var F:TTextRec) : Integer; far;
var
  ps: PStringFileIO;
begin
  With F do
  begin
    ps := HStringFileIO(@UserData[1])^;
    with ps^ do
    Case Mode of
      fmInput:
        begin
          Index := 0;
          rdPos := 1;
          InOutFunc := @Input;
          FlushFunc := @DoNothing;
          end;
      fmInOut:
        begin
          Mode := fmOutput;
          Index := Strings.Count;
          InOutFunc := @output;
          FlushFunc := @output;
          end;
      fmOutput:
        begin
          Strings.Clear;
          Index := 0;
          InOutFunc := @Output;
          FlushFunc := @Output;
          end;
    end;{CASE}
    Result := 0;
  end;
end;

procedure AssignStrings(var F:TextFile;Strings:TStrings);
var
  ps:PSTringFileIO;

begin
  FillChar(F,sizeof(TTextRec),#0);
  With TTextRec(F) do
  begin
    {$IFNDEF WIN32}
    Handle := CARDINAL(-1);
    {$ELSE}
    Handle := -1;
    {$ENDIF}
    Mode := fmClosed;
    BufSize := SizeOf(Buffer);
    BufPtr := @Buffer;
    OpenFunc := @Open;
    CloseFunc := @CloseStrFileIO;

    ps := PStringFileIO(AllocMem(sizeof(TStringFileIO)));

    HStringFileIO(@UserData[1])^ := ps;
    ps^.Strings := Strings;
    ps^.rdPos := 1;
    Name[0] := #0;
  end;
end;

end.


